| D++ (DPP) C++ Discord API Bot Library

Search
Loading...
Searching...
No Matches
dpp::scheduled_event Struct Reference

A scheduled event. More...

`#include <scheduled_event.h>`

Inheritance diagram for dpp::scheduled_event:
[legend]
Collaboration diagram for dpp::scheduled_event:
[legend]

## Public Member Functions

| scheduled_event ()
| Create a scheduled_event object.
std::string | build_json (bool with_id=false) const
| Convert object to json string.
scheduled_event & | clear_description ()
| Clear the description of the event.
scheduled_event & | fill_from_json (nlohmann::json *j)
| Convert object from nlohmann::json.
constexpr double | get_creation_time () const noexcept
| Get the creation time of this object according to Discord.
scheduled_event & | load_image (const std::byte *data, uint32_t size, const image_type type)
| Load an image for the event cover.
scheduled_event & | load_image (std::string_view image_blob, const image_type type)
| Load an image for the event cover.
constexpr bool | operator!= (const managed &other) const noexcept
| Comparison operator for comparing two managed objects by id.
constexpr bool | operator== (const managed &other) const noexcept
| Comparison operator for comparing two managed objects by id.
scheduled_event & | set_channel_id (snowflake c)
| Set the voice channel id of the event.
scheduled_event & | set_creator_id (snowflake c)
| Set the creator id of the event.
scheduled_event & | set_description (const std::string &d)
| Set the description of the event. Minimum length: 1 (if set), Maximum length: 100.
scheduled_event & | set_end_time (time_t t)
| Set the end time of the event.
scheduled_event & | set_location (const std::string &l)
| Set the location of the event. Minimum length: 1, Maximum length: 1000.
scheduled_event & | set_name (const std::string &n)
| Set the name of the event. Minimum length: 1, Maximum length: 100.
scheduled_event & | set_start_time (time_t t)
| Set the start time of the event.
scheduled_event & | set_status (event_status s)
| Set the status of the event.
auto | to_json (bool with_id=false) const
| Convert object to nlohmann::json.

## Public Attributes

snowflake | channel_id
| The channel ID in which the scheduled event will be hosted, or null if scheduled entity type is EXTERNAL.
user | creator
| Optional: The creator of the scheduled event.
snowflake | creator_id
| Optional: The ID of the user that created the scheduled event.
std::string | description
| Optional: The description of the scheduled event (1-1000 characters).
snowflake | entity_id
| Any additional ID of the hosting entity associated with event. e.g. stage instance ID.
event_entities | entity_metadata
| The entity metadata for the scheduled event.
event_entity_type | entity_type
| The type of hosting entity associated with a scheduled event. e.g. voice channel or stage channel.
snowflake | guild_id
| The guild ID which the scheduled event belongs to.
snowflake | id = {}
| Unique ID of object set by Discord. This value contains a timestamp, worker ID, internal server ID, and an incrementing value. Only the timestamp is relevant to us as useful metadata.
utility::icon | image
| The image of the scheduled event.
std::string | name
| The name of the scheduled event.
event_privacy_level | privacy_level
| The privacy level of the scheduled event.
time_t | scheduled_end_time
| The time the scheduled event will end, or null if the event does not have a scheduled time to end.
time_t | scheduled_start_time
| The time the scheduled event will start.
event_status | status
| The status of the scheduled event.
uint32_t | user_count
| Optional: The number of users subscribed to the scheduled event.

## Protected Member Functions

scheduled_event & | fill_from_json_impl (const nlohmann::json *j)
| Serialise a scheduled_event object from json.
json | to_json_impl (bool with_id=false) const
| Build json for this object.

## Friends

struct | json_interface< scheduled_event >

## Detailed Description

A scheduled event.

## Constructor & Destructor Documentation

## ◆ scheduled_event()

dpp::scheduled_event::scheduled_event | ( |  | ) |

Create a scheduled_event object.

## Member Function Documentation

## ◆ build_json()

std::string dpp::json_interface< scheduled_event >::build_json | ( | bool | with_id = false | ) | const

inline inherited

Convert object to json string.

Parameters

  with_id | Whether to include the ID or not

Note
  Some fields are conditionally filled, do not rely on all fields being present

Returns
  std::string Json built from the structure

## ◆ clear_description()

scheduled_event & dpp::scheduled_event::clear_description | ( |  | ) |

Clear the description of the event.

Returns
  scheduled_event& reference to self

## ◆ fill_from_json()

scheduled_event & dpp::json_interface< scheduled_event >::fill_from_json | ( | nlohmann::json * | j | ) |

inline inherited

Convert object from nlohmann::json.

Parameters

  j | nlohmann::json object

Returns
  T& Reference to self for fluent calling

## ◆ fill_from_json_impl()

scheduled_event & dpp::scheduled_event::fill_from_json_impl | ( | const nlohmann::json * | j | ) |

protected

Serialise a scheduled_event object from json.

Returns
  scheduled_event& a reference to self

## ◆ get_creation_time()

double dpp::managed::get_creation_time | ( |  | ) | const

inline constexpr noexcept inherited

Get the creation time of this object according to Discord.

Returns
  double creation time inferred from the snowflake ID. The minimum possible value is the first second of 2015.

## ◆ load_image() [1/2]

scheduled_event & dpp::scheduled_event::load_image | ( | const std::byte * | data,
|  | uint32_t | size,
|  | const image_type | type )

Load an image for the event cover.

Parameters

  data | Image binary data
  size | Size of the image.
  type | Type of image. It can be one of i_gif, i_jpg or i_png.

Returns
  emoji& Reference to self

## ◆ load_image() [2/2]

scheduled_event & dpp::scheduled_event::load_image | ( | std::string_view | image_blob,
|  | const image_type | type )

Load an image for the event cover.

Parameters

  image_blob | Image binary data
  type | Type of image. It can be one of i_gif, i_jpg or i_png.

Returns
  emoji& Reference to self

## ◆ operator!=()

bool dpp::managed::operator!= | ( | const managed & | other | ) | const

inline constexpr noexcept inherited

Comparison operator for comparing two managed objects by id.

Parameters

  other | Other object to compare against

Returns
  true objects are not the same id
  false objects are the same id

## ◆ operator==()

bool dpp::managed::operator== | ( | const managed & | other | ) | const

inline constexpr noexcept inherited

Comparison operator for comparing two managed objects by id.

Parameters

  other | Other object to compare against

Returns
  true objects are the same id
  false objects are not the same id

## ◆ set_channel_id()

scheduled_event & dpp::scheduled_event::set_channel_id | ( | snowflake | c | ) |

Set the voice channel id of the event.

Note
  clears location

Parameters

  c | channel ID

Returns
  scheduled_event& reference to self

## ◆ set_creator_id()

scheduled_event & dpp::scheduled_event::set_creator_id | ( | snowflake | c | ) |

Set the creator id of the event.

Parameters

  c | creator user ID

Returns
  scheduled_event& reference to self

## ◆ set_description()

scheduled_event & dpp::scheduled_event::set_description | ( | const std::string & | d | ) |

Set the description of the event. Minimum length: 1 (if set), Maximum length: 100.

Parameters

  d | event description

Returns
  scheduled_event& reference to self

Exceptions

  dpp::length_error | if length < 1

## ◆ set_end_time()

scheduled_event & dpp::scheduled_event::set_end_time | ( | time_t | t | ) |

Set the end time of the event.

Parameters

  t | ending time

Returns
  scheduled_event& reference to self

Exceptions

  dpp::length_error | if time is before now

## ◆ set_location()

scheduled_event & dpp::scheduled_event::set_location | ( | const std::string & | l | ) |

Set the location of the event. Minimum length: 1, Maximum length: 1000.

Note
  Clears channel_id

Parameters

  l | event location

Returns
  scheduled_event& reference to self

Exceptions

  dpp::length_error | if length < 1

## ◆ set_name()

scheduled_event & dpp::scheduled_event::set_name | ( | const std::string & | n | ) |

Set the name of the event. Minimum length: 1, Maximum length: 100.

Parameters

  n | event name

Returns
  scheduled_event& reference to self

Exceptions

  dpp::length_error | if length < 1

## ◆ set_start_time()

scheduled_event & dpp::scheduled_event::set_start_time | ( | time_t | t | ) |

Set the start time of the event.

Parameters

  t | starting time

Returns
  scheduled_event& reference to self

Exceptions

  dpp::length_error | if time is before now

## ◆ set_status()

scheduled_event & dpp::scheduled_event::set_status | ( | event_status | s | ) |

Set the status of the event.

Parameters

  s | status to set

Returns
  scheduled_event& reference to self

Exceptions

  dpp::logic_exception | if status change is not valid

## ◆ to_json()

auto dpp::json_interface< scheduled_event >::to_json | ( | bool | with_id = false | ) | const

inline inherited

Convert object to nlohmann::json.

Parameters

  with_id | Whether to include the ID or not

Note
  Some fields are conditionally filled, do not rely on all fields being present

Returns
  json Json built from the structure

## ◆ to_json_impl()

json dpp::scheduled_event::to_json_impl | ( | bool | with_id = false | ) | const

protected

Build json for this object.

Parameters

  with_id | Include id field in json

Returns
  std::string Json of this object

## Friends And Related Symbol Documentation

## ◆ json_interface< scheduled_event >

friend struct json_interface< scheduled_event >

friend

## Member Data Documentation

## ◆ channel_id

snowflake dpp::scheduled_event::channel_id

The channel ID in which the scheduled event will be hosted, or null if scheduled entity type is EXTERNAL.

Note
  This may be empty.

## ◆ creator

user dpp::scheduled_event::creator

Optional: The creator of the scheduled event.

## ◆ creator_id

snowflake dpp::scheduled_event::creator_id

Optional: The ID of the user that created the scheduled event.

## ◆ description

std::string dpp::scheduled_event::description

Optional: The description of the scheduled event (1-1000 characters).

## ◆ entity_id

snowflake dpp::scheduled_event::entity_id

Any additional ID of the hosting entity associated with event. e.g. stage instance ID.

Note
  This may be empty.

## ◆ entity_metadata

event_entities dpp::scheduled_event::entity_metadata

The entity metadata for the scheduled event.

Note
  This may be empty.

## ◆ entity_type

event_entity_type dpp::scheduled_event::entity_type

The type of hosting entity associated with a scheduled event. e.g. voice channel or stage channel.

## ◆ guild_id

snowflake dpp::scheduled_event::guild_id

The guild ID which the scheduled event belongs to.

## ◆ id

snowflake dpp::managed::id = {}

inherited

Unique ID of object set by Discord. This value contains a timestamp, worker ID, internal server ID, and an incrementing value. Only the timestamp is relevant to us as useful metadata.

## ◆ image

utility::icon dpp::scheduled_event::image

The image of the scheduled event.

Note
  This may be empty.

## ◆ name

std::string dpp::scheduled_event::name

The name of the scheduled event.

## ◆ privacy_level

event_privacy_level dpp::scheduled_event::privacy_level

The privacy level of the scheduled event.

## ◆ scheduled_end_time

time_t dpp::scheduled_event::scheduled_end_time

The time the scheduled event will end, or null if the event does not have a scheduled time to end.

Note
  This may be empty.

## ◆ scheduled_start_time

time_t dpp::scheduled_event::scheduled_start_time

The time the scheduled event will start.

## ◆ status

event_status dpp::scheduled_event::status

The status of the scheduled event.

## ◆ user_count

uint32_t dpp::scheduled_event::user_count

Optional: The number of users subscribed to the scheduled event.

D++ Library version 9.0.13 D++ Library version 9.0.12 D++ Library version 9.0.11 D++ Library version 9.0.10 D++ Library version 9.0.9 D++ Library version 9.0.8 D++ Library version 9.0.7 D++ Library version 9.0.6 D++ Library version 9.0.5 D++ Library version 9.0.4 D++ Library version 9.0.3 D++ Library version 9.0.2 D++ Library version 9.0.1 D++ Library version 9.0.0 D++ Library version 1.0.2 D++ Library version 1.0.1 D++ Library version 1.0.0